USACO 06 NOV Bad Hair Day【单调栈】

版权声明:转载什么的好说,附上友链就ojek了,同为咸鱼,一起学习。 https://blog.csdn.net/sodacoco/article/details/86945018

新年第二题被单调栈教做人。

题目:

Some of Farmer John's N cows (1 ≤ N ≤ 80,000) are having a bad hair day! Since each cow is self-conscious about her messy hairstyle, FJ wants to count the number of other cows that can see the top of other cows' heads.

Each cow i has a specified height hi (1 ≤ hi ≤ 1,000,000,000) and is standing in a line of cows all facing east (to the right in our diagrams). Therefore, cow i can see the tops of the heads of cows in front of her (namely cows i+1, i+2, and so on), for as long as these cows are strictly shorter than cow i.

Consider this example:

        =
=       =
=   -   =         Cows facing right -->
=   =   =
= - = = =
= = = = = =
1 2 3 4 5 6 

Cow#1 can see the hairstyle of cows #2, 3, 4
Cow#2 can see no cow's hairstyle
Cow#3 can see the hairstyle of cow #4
Cow#4 can see no cow's hairstyle
Cow#5 can see the hairstyle of cow 6
Cow#6 can see no cows at all!

Let ci denote the number of cows whose hairstyle is visible from cow i; please compute the sum of c1 through cN.For this example, the desired is answer 3 + 0 + 1 + 0 + 1 + 0 = 5.

Input

Line 1: The number of cows, N
Lines 2..N+1: Line i+1 contains a single integer that is the height of cow i.

Output

Line 1: A single integer that is the sum of c 1 through cN.

Sample Input

6
10
3
7
4
12
2

Sample Output

5

题目大意:

       给定 n 个数,对于第 i 个数,求需要向右经过 k 个数,可以找到第一个比它本身大的数,求这 n 个数 k 的和。

解题思路:

       一开始想到了用递归,对于每一个数,记录其右边第一个比它大的数的距离,然后每一个数都向右递归寻找第一个比他大的数的距离,最后遍历求和得到结果。

       出于对最坏的情况的复杂度的畏惧,放弃这个方案。

       看看题目合集,单调栈&单调队列,这个只是有个印象,至于用法,,

       看了许久,被一张图拯救了:

        我跟着很多程序走了很多遍,怎么都理解不了这个实现过程,这个图验证了我的猜想:

        实现的过程是以每头牛为“受体”,每只牛“被” 几只牛看到。而我一直以牛为主体的角度,认为应该:

      这样,这张图所表达的是每头牛能够看到几头牛。两者的总和相同,但是单调栈的思想就在这儿了,麻油,开心。

实现代码:

      【菜鸟选择了最简单的操作方式】

#include <stack>
#include <cstdio>
#include <iostream>
#define MAXN 80007
using namespace std;

stack<int> st;
long long ans;
int n, h[MAXN], c[MAXN];

int main() {
	scanf("%d", &n);
	for(int i=1; i<=n; i++) {
		scanf("%d", &h[i]);
		while(!st.empty() && st.top()<=h[i]) {
			st.pop();
		}
		ans += st.size();
		st.push(h[i]);
	}
	printf("%lld", ans);
}

 

猜你喜欢

转载自blog.csdn.net/sodacoco/article/details/86945018